//
//  GradeDetailView.swift
//  UIGrades
//
//  Created by Joe Gregg on 11/5/22.
//

import SwiftUI

struct GradeDetailView: View {
    @Environment(\.managedObjectContext) var moc
    let grade : Grade!
    let student : Student!
    let quiz : Quiz!
    @State var score : String
    
    init(grade g : Grade!,student s : Student!,quiz q : Quiz!) {
        grade = g
        student = s
        quiz = q
        if let gr = grade {
            _score = State(initialValue: String(gr.points))
        } else {
            _score = State(initialValue: "")
        }
    }
    
    var body: some View {
        VStack {
            HStack {
                Text("Score:")
                TextField("",text:$score)
            }
            Button("Save") {
                if let g = grade {
                    g.points = Int32(score) ?? 0
                } else {
                    let g = Grade(context: moc)
                    g.id = UUID()
                    g.quiz = quiz
                    g.student = student
                    g.points = Int32(score) ?? 0
                }
                try? moc.save()
            }
        }
    }
    
}

struct GradeDetailView_Previews: PreviewProvider {
    static var previews: some View {
        GradeDetailView(grade:nil,student: nil,quiz:nil)
    }
}
