//
//  QuizView.swift
//  UIGrades
//
//  Created by Joe Gregg on 11/4/22.
//

import SwiftUI

struct QuizView: View {
    @Environment(\.managedObjectContext) var moc
    @FetchRequest(sortDescriptors: []) var quizzes : FetchedResults<Quiz>
    @State var name : String = ""
    @State var max_points : String = ""
    var body: some View {
        VStack {
            List {
                ForEach(quizzes) { quiz in
                    Text(quiz.name ?? "Unknown")
                }.onDelete(perform: delete)
            }
            HStack {
                Text("Name:")
                TextField("",text:$name).disableAutocorrection(true).textFieldStyle(.roundedBorder)
            }
            HStack {
                Text("Points:")
                TextField("",text:$max_points).disableAutocorrection(true).textFieldStyle(.roundedBorder)
            }
            Button("Add Quiz") {
                let quiz = Quiz(context: moc)
                quiz.id = UUID()
                quiz.name = name
                quiz.max_points = Int32(max_points) ?? 100
                try? moc.save()
            }
        }
    }
    
    func delete(at offsets: IndexSet) {
        offsets.forEach { i in
            moc.delete(quizzes[i])
            try? moc.save()
        }
    }
}


struct QuizView_Previews: PreviewProvider {
    static var dataController = DataController()
    static var previews: some View {
        QuizView().environment(\.managedObjectContext, dataController.container.viewContext)
    }
}
